Index: engine/jitc_pinvoke.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc_pinvoke.c,v
retrieving revision 1.3
diff -c -r1.3 jitc_pinvoke.c
*** engine/jitc_pinvoke.c	28 Jul 2006 17:41:54 -0000	1.3
--- engine/jitc_pinvoke.c	16 Sep 2006 13:26:34 -0000
***************
*** 625,673 ****
  	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToAnsi",
! 						    ILStringToAnsi,
! 						    _ILJitSignature_ILStringToAnsi,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToUTF8",
! 						    ILStringToUTF8,
! 						    _ILJitSignature_ILStringToUTF8,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringToUTF16",
! 						    ILStringToUTF16,
! 						    _ILJitSignature_ILStringToUTF16,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			default:
  			{
! 				fprintf(stderr, "Unsupported string char set in marshaling\n");
! 				return 0;
! 			};
  	    }
  
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  		    jit_insn_store_relative(function, outAddressValue, offset, temp);
  	    return temp;
      }
! 
!     else if(type!=0 && ILTypeIsDelegate(type))
      {
  	    temp = jit_insn_dup(function, in);
  	    if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE)
--- 920,976 ----
  	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
+ 	    char *customName;
+ 	    int customNameLen;
+ 	    char *customCookie;
+ 	    int customCookieLen;
+ 	    ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
+ 	    marshalType = ILPInvokeGetMarshalType
+ 			    (0, method, 0, &customName, &customNameLen, &customCookie, &customCookieLen, type);
  
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToAnsi",
! 							    ILStringToAnsi,
! 							    _ILJitSignature_ILStringToAnsi,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringToUTF8",
! 							    ILStringToUTF8,
! 							    _ILJitSignature_ILStringToUTF8,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 	    						    "ILStringToUTF16",
! 							    ILStringToUTF16,
! 							    _ILJitSignature_ILStringToUTF16,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			default:
  			{
! 				temp = args[1];
! 			}
! 			break;
  	    }
  
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
+ 	    {
  		    jit_insn_store_relative(function, outAddressValue, offset, temp);
+ 	    }
  	    return temp;
      }
!     else if(type!=0 && ILTypeIsDelegateSubClass(type))
      {
  	    temp = jit_insn_dup(function, in);
  	    if(addressKind!=MARSHAL_FIRST_LEVEL_VALUE)
***************
*** 676,689 ****
  	    }
  	    ILJitValue closure = jit_insn_load_relative(function, temp, offsetof(System_Delegate, closure), _IL_JIT_TYPE_VPTR);
  	    jit_insn_branch_if(function, jit_insn_to_bool(function, closure), &endLabel);
! 	    args[0] = _ILJitFunctionGetThread(function);
! 	    args[1] = jit_insn_dup(function, temp);
! 	    args[2] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)type);
  	    jit_insn_store(function, closure, jit_insn_call_native(function,
  					    "ILJitDelegateGetClosure",
  					    ILJitDelegateGetClosure,
  					    _ILJitSignature_ILJitDelegateGetClosure,
! 					    args, 3, JIT_CALL_NOTHROW));
  	    jit_insn_label(function, &endLabel);
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  		    jit_insn_store_relative(function, outAddressValue, offset, closure);
--- 979,991 ----
  	    }
  	    ILJitValue closure = jit_insn_load_relative(function, temp, offsetof(System_Delegate, closure), _IL_JIT_TYPE_VPTR);
  	    jit_insn_branch_if(function, jit_insn_to_bool(function, closure), &endLabel);
! 	    args[0] = jit_insn_dup(function, temp);
! 	    args[1] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)type);
  	    jit_insn_store(function, closure, jit_insn_call_native(function,
  					    "ILJitDelegateGetClosure",
  					    ILJitDelegateGetClosure,
  					    _ILJitSignature_ILJitDelegateGetClosure,
! 					    args, 2, JIT_CALL_NOTHROW));
  	    jit_insn_label(function, &endLabel);
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  		    jit_insn_store_relative(function, outAddressValue, offset, closure);
***************
*** 707,716 ****
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    elemType = ILType_Ref(type);
  			    if(NeedMarshalValue(elemType))
  			    {
  				        MarshalValue(function, jit_insn_dup(function, srcArray),
! 						    	    elemType, 0, 
  							    MARSHAL_ITEM_OF_STRUCTURE,
  							    0,
  							    jit_insn_dup(function, srcArray));
--- 1009,1019 ----
  				    jit_insn_store(function, srcArray, jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR));
  			    else jit_insn_store(function, srcArray, in);
  			    elemType = ILType_Ref(type);
+ 			    elemType = ILTypeGetEnumType(elemType);
  			    if(NeedMarshalValue(elemType))
  			    {
  				        MarshalValue(function, jit_insn_dup(function, srcArray),
! 						    	    elemType, marshalType, 
  							    MARSHAL_ITEM_OF_STRUCTURE,
  							    0,
  							    jit_insn_dup(function, srcArray));
***************
*** 720,813 ****
  			    return srcArray;
  		    }
  		    break;
! 		    default: break;
! 		    }
  
! 		    if(ILType_IsSimpleArray(type))
  		    {
! 			    srcArray = in;
! 			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
! 			    elemType = ILType_ElemType(type);
! 			    if(!NeedMarshalValue(elemType))
  			    {
! 				    jit_insn_store(function, newArray, srcArray);
! 				    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
! 				    {
! 					    jit_insn_store(function, newArray, jit_insn_add_relative(function,
! 				    	    					newArray,
! 				    						(jit_nint)(sizeof(ILUInt32))));
! 				    }
! 				    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 				    	    jit_insn_store_relative(function, outAddressValue, offset, newArray);
! 				    return newArray;
  			    }
- 
- 			    // The size of a simple array can be known only on run-time.
- 			    arraySize = jit_insn_load_relative(function, srcArray, 0, _IL_JIT_TYPE_UINT32);
- 			    thread = ILExecThreadCurrent();
- 			    srcElemSize = jit_value_create_nint_constant(function,
- 				    						_IL_JIT_TYPE_INT32,
- 										(jit_nint)(ILSizeOfType(thread, elemType)));
- 			    newElemSize = jit_value_create_nint_constant(function,
- 										_IL_JIT_TYPE_INT32,
- 									    	(jit_nint)(ILSizeOfType(thread, elemType)));
- 			    newArraySize = jit_insn_mul(function, arraySize, newElemSize);
- 			    newArraySize = jit_insn_add_relative(function, newArraySize, (jit_nint)sizeof(ILUInt32));
- 		 	    args[0] = newArraySize;
- 			    jit_insn_store(function, newArray, jit_insn_call_native(function, "_ILMalloc",
- 			    			    			ILGCAlloc,
- 			    			    			_ILJitSignature_malloc,
- 			    						args, 1, 0));
- 
- 			    jit_insn_branch_if(function,
- 						jit_insn_eq(function, arraySize,
- 									jit_value_create_nint_constant
- 										(function, _IL_JIT_TYPE_UINT32, 0)),
- 										&endLoop);
- 			    srcElemAddress = jit_insn_add_relative(function,
- 									srcArray,
- 									(jit_nint)(sizeof(ILUInt32)));
- 			    newElemAddress = jit_insn_dup(function, newArray);
- 			    counter = arraySize;
- 			    jit_insn_label(function, &startLoop);
- 			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
- 		    									jit_value_create_nint_constant(function,
- 											_IL_JIT_TYPE_INT32,
- 											1)));
- 			    MarshalValue(function, jit_insn_dup(function, srcElemAddress),
- 							elemType, 0,
- 							MARSHAL_ITEM_OF_ARRAY,
- 							0,
- 							jit_insn_dup(function, newElemAddress));
- 			    jit_insn_store(function, srcElemAddress,
- 							    jit_insn_add(function,
- 							    srcElemAddress, srcElemSize));
- 			    jit_insn_store(function, newElemAddress,
- 							jit_insn_add(function,
- 							newElemAddress, newElemSize));
- 			    jit_insn_branch_if(function,
- 					        jit_insn_to_bool(function, counter),
- 					        &(startLoop));
- 			    jit_insn_label(function, &endLoop);
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 					jit_insn_store_relative(function, outAddressValue, offset, newArray);
  			    return newArray;
  		    }
! 		    else if (ILType_IsArray(type))
! 		    {
! 			    fprintf(stderr, "Multidimential arrays are not supported for marshaling\n");
!     		    	    return 0;
!     		    }
      }
- 
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
      temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
      jit_insn_store_relative(function, outAddressValue, offset, temp);
      return temp;
  }
  
! static ILJitValue MarshalStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
          ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
  	ILExecThread *thread = ILExecThreadCurrent();
--- 1023,1117 ----
  			    return srcArray;
  		    }
  		    break;
!     		    default: break;
! 	    }
  
! 	    if(ILType_IsSimpleArray(type))
! 	    {
! 		    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 			    srcArray = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
! 		    else srcArray = in;
! 		    jit_insn_store(function, newArray, srcArray);
! 		    jit_insn_branch_if_not(function, jit_insn_to_bool(function, newArray),
! 						    &endLoop);
! 		    elemType = ILType_ElemType(type);
! 		    elemType = ILTypeGetEnumType(elemType);
! 		    if(!NeedMarshalValue(elemType))
  		    {
! 			    jit_insn_store(function, newArray, srcArray);
! 			    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
  			    {
! 				    jit_insn_store(function, newArray, jit_insn_add_relative(function,
! 				    	    				newArray,
! 				    					(jit_nint)(sizeof(ILUInt32))));
  			    }
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 				    	jit_insn_store_relative(function, outAddressValue, offset, newArray);
  			    return newArray;
  		    }
! 		    // The size of a simple array can be known only on run-time.
! 		    arraySize = jit_insn_load_relative(function, srcArray, 0, _IL_JIT_TYPE_UINT32);
! 		    thread = ILExecThreadCurrent();
! 		    srcElemSize = jit_value_create_nint_constant(function,
! 			    						_IL_JIT_TYPE_INT32,
! 									(jit_nint)(ILSizeOfType(thread, elemType)));
! 		    newElemSize = jit_value_create_nint_constant(function,
! 									_IL_JIT_TYPE_INT32,
! 								    	(jit_nint)(ILSizeOfType(thread, elemType)));
! 		    newArraySize = jit_insn_mul(function, arraySize, newElemSize);
! 		    args[0] = newArraySize;
! 		    jit_insn_store(function, newArray, jit_insn_call_native(function, "ILGCAllocAtomic",
! 			    						ILGCAllocAtomic,
! 			    				    		_ILJitSignature_malloc,
! 			    						args, 1, 0));
! 		    jit_insn_branch_if(function,
! 					jit_insn_eq(function, arraySize,
! 							    jit_value_create_nint_constant
! 									(function, _IL_JIT_TYPE_UINT32, 0)),
! 									&endLoop);
! 		    srcElemAddress = jit_insn_add_relative(function,
! 								srcArray,
! 								(jit_nint)(sizeof(ILUInt32)));
! 		    newElemAddress = jit_value_create(function, jit_type_int);
! 		    jit_insn_store(function, newElemAddress, newArray);
! 		    counter = jit_insn_dup(function, arraySize);
! 		    jit_insn_label(function, &startLoop);
! 		    jit_insn_store(function, counter, jit_insn_sub(function, counter,
! 		    								jit_value_create_nint_constant(function,
! 										_IL_JIT_TYPE_INT32,
! 										1)));
! 		    MarshalValue(function, srcElemAddress, elemType,
! 							    marshalType,
! 							    MARSHAL_ITEM_OF_ARRAY,
! 							    0,
! 							    newElemAddress);
! 		    jit_insn_store(function, srcElemAddress,
! 						    jit_insn_add(function,
! 						    srcElemAddress, srcElemSize));
! 		    jit_insn_store(function, newElemAddress,
! 						jit_insn_add(function,
! 						newElemAddress, newElemSize));
! 		    jit_insn_branch_if(function,
! 					    jit_insn_to_bool(function, counter),
! 					    &(startLoop));
! 		    jit_insn_label(function, &endLoop);
! 		    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 				jit_insn_store_relative(function, outAddressValue, offset, newArray);
! 		    return newArray;
! 	    }
! 	    else if (ILType_IsArray(type))
! 	    {
! 		    fprintf(stderr, "Multidimential arrays are not supported for marshaling\n");
!     		    return 0;
!     	    }
      }
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
      temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
      jit_insn_store_relative(function, outAddressValue, offset, temp);
      return temp;
  }
  
! static ILJitValue MarshalStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
          ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
  	ILExecThread *thread = ILExecThreadCurrent();
***************
*** 820,826 ****
  		case MARSHAL_FIRST_LEVEL_VALUE:
  		{
  			ILJitValue sizeValue = jit_value_create_nint_constant(function, _IL_JIT_TYPE_UINT32, structSize);
! 			outAddress = jit_insn_call_native(function, "_ILMalloc",
  								    ILGCAlloc,
  								    _ILJitSignature_malloc,
  								    &sizeValue, 1, 0);
--- 1124,1130 ----
  		case MARSHAL_FIRST_LEVEL_VALUE:
  		{
  			ILJitValue sizeValue = jit_value_create_nint_constant(function, _IL_JIT_TYPE_UINT32, structSize);
! 			outAddress = jit_insn_call_native(function, "ILGCAlloc",
  								    ILGCAlloc,
  								    _ILJitSignature_malloc,
  								    &sizeValue, 1, 0);
***************
*** 850,908 ****
  			{
  				case MARSHAL_FIRST_LEVEL_VALUE:
  				{
! 					MarshalValue(function, inAddress, type, 0, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  				}
  			        break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					MarshalValue(function, inAddress, type, 0, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  				}
  				break;
  				default:
  				{
! 					MarshalValue(function, inAddress, type, 0, MARSHAL_ITEM_OF_ARRAY, field->offset + offset, outAddress);
  				}
  				break;
  			}
  		}
  	}
- 	
  	return outAddress;
  }
  
! 
! static ILJitValue MarshalReturnValue(jit_function_t function, ILJitValue in, ILType *type, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
!     ILJitValue retValue;    
      ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
      ILJitValue args[3];
      ILJitValue srcArray = jit_value_create(function, _IL_JIT_TYPE_VPTR);
-     ILUInt32 marshalType;
-     char *customName;
-     int customNameLen;
-     char *customCookie;
-     int customCookieLen;
-     ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
-     ILPInvoke *pinv = ILPInvokeFind(method);
-     marshalType = ILPInvokeGetMarshalType(pinv, method, 1, &customName, &customNameLen,
- 							&customCookie,	&customCookieLen, type);
-     if(marshalType == IL_META_MARSHAL_DIRECT && addressKind==MARSHAL_FIRST_LEVEL_VALUE)
-     {
- 	    return in;
-     }
-     else if(marshalType == IL_META_MARSHAL_CUSTOM)
-     {
- 	    fprintf(stderr, "custom marshaling of return value is not supported\n");
- 	    return 0;
-     }
      type = ILTypeGetEnumType(type);
  
-     if(addressKind==MARSHAL_FIRST_LEVEL_VALUE && !NeedMarshalValue(type))
-     {
- 	    return in;
-     }
- 
      switch(addressKind)
      {    
  	    case MARSHAL_FIRST_LEVEL_VALUE:
--- 1154,1187 ----
  			{
  				case MARSHAL_FIRST_LEVEL_VALUE:
  				{
! 					MarshalValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  				}
  			        break;
  				case MARSHAL_ITEM_OF_STRUCTURE:
  				{
! 					MarshalValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  				}
  				break;
  				default:
  				{
! 					MarshalValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_ARRAY, field->offset + offset, outAddress);
  				}
  				break;
  			}
  		}
  	}
  	return outAddress;
  }
  
! static ILJitValue MarshalReturnValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
!     ILJitValue retValue;
      ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
      ILJitValue args[3];
      ILJitValue srcArray = jit_value_create(function, _IL_JIT_TYPE_VPTR);
      type = ILTypeGetEnumType(type);
  
      switch(addressKind)
      {    
  	    case MARSHAL_FIRST_LEVEL_VALUE:
***************
*** 1062,1105 ****
      }
      else if(ILType_IsValueType(type))
      {
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return (ILJitValue)MarshalReturnStruct(function, jit_insn_address_of(function, in), type, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
! 	    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
! 	    retValue = (ILJitValue)MarshalReturnStruct(function, temp, type, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  	    jit_insn_store_relative(function, outAddressValue, offset, retValue);
  	    return retValue;
      }
      else if(ILTypeIsStringClass(type))
      {
  	    args[0] = _ILJitFunctionGetThread(function);
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
  						    "ILStringCreate",
  						    ILStringCreate,
  						    _ILJitSignature_ILStringCreate,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
  						    "ILStringCreateUTF8",
  						    ILStringCreateUTF8,
  						    _ILJitSignature_ILStringCreateUTF8,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringWCreate",
! 						    ILStringWCreate,
! 						    _ILJitSignature_ILStringWCreate,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  	    }
--- 1341,1395 ----
      }
      else if(ILType_IsValueType(type))
      {
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return (ILJitValue)MarshalReturnStruct(function, jit_insn_address_of(function, in), type, marshalType, 0, 0, MARSHAL_FIRST_LEVEL_VALUE);
! 	    retValue = (ILJitValue)MarshalReturnStruct(function, in, type, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  	    jit_insn_store_relative(function, outAddressValue, offset, retValue);
  	    return retValue;
      }
      else if(ILTypeIsStringClass(type))
      {
  	    args[0] = _ILJitFunctionGetThread(function);
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = jit_insn_dup(function, in);
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
+ 	    char *customName;
+ 	    int customNameLen;
+ 	    char *customCookie;
+ 	    int customCookieLen;
+ 	    ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
+ 	    marshalType = ILPInvokeGetMarshalType
+ 			    (0, method, 0, &customName, &customNameLen, &customCookie, &customCookieLen, type);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				temp = jit_insn_call_native(function,
  						    "ILStringCreate",
  						    ILStringCreate,
  						    _ILJitSignature_ILStringCreate,
! 						    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				temp = jit_insn_call_native(function,
  						    "ILStringCreateUTF8",
  						    ILStringCreateUTF8,
  						    _ILJitSignature_ILStringCreateUTF8,
! 						    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringWCreate",
! 							    ILStringWCreate,
! 							    _ILJitSignature_ILStringWCreate,
! 							    args, 2, JIT_CALL_NOTHROW);
! 			}
! 			break;
! 			default:
! 			{
! 				temp = args[1];
  			}
  			break;
  	    }
***************
*** 1112,1126 ****
  	    fprintf(stderr, "Marshaling of a delegate as a return value is not supported\n");
  	    return 0;
      }
!     else if(ILType_IsClass(type))
!     {
! 	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
! 	    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
! 	    jit_insn_store_relative(function, outAddressValue, offset, temp);
! 	    retValue = temp;
! 	    return retValue;
!     }
!     else if(type !=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
--- 1402,1408 ----
  	    fprintf(stderr, "Marshaling of a delegate as a return value is not supported\n");
  	    return 0;
      }
!     else if(type!=0 && ILType_IsComplex(type))
      {
  	    switch(ILType_Kind(type))
  	    {
***************
*** 1130,1136 ****
  			    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  			    jit_insn_store_relative(function, outAddressValue, offset, temp);
  			    return temp;
! 		    };
  		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
--- 1412,1418 ----
  			    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  			    jit_insn_store_relative(function, outAddressValue, offset, temp);
  			    return temp;
! 		    }
  		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
***************
*** 1141,1147 ****
  			    if(NeedMarshalValue(elemType))
  			    {
  				    MarshalReturnValue(function, jit_insn_dup(function, srcArray),
! 								    elemType,
  								    MARSHAL_ITEM_OF_STRUCTURE,
  								    0,
  								    jit_insn_dup(function, srcArray));
--- 1423,1429 ----
  			    if(NeedMarshalValue(elemType))
  			    {
  				    MarshalReturnValue(function, jit_insn_dup(function, srcArray),
! 								    elemType, marshalType,
  								    MARSHAL_ITEM_OF_STRUCTURE,
  								    0,
  								    jit_insn_dup(function, srcArray));
***************
*** 1158,1166 ****
  	    {
  			// The size of a simple array can be known only on run-time 
  			// and we cannot use the same return memory as it is allocated in C code.
  			fprintf(stderr, "Simple arrays not supported for marshaling as a return value");
! 			return 0;
! 			
  	    }
  	    else if(ILType_IsArray(type))
  	    {
--- 1440,1448 ----
  	    {
  			// The size of a simple array can be known only on run-time 
  			// and we cannot use the same return memory as it is allocated in C code.
+ 			// However, it is easy to be implemented using the MarshalValue case.
  			fprintf(stderr, "Simple arrays not supported for marshaling as a return value");
! 			return 0;			
  	    }
  	    else if(ILType_IsArray(type))
  	    {
***************
*** 1170,1183 ****
  
      }
  
-     // Do something smart.
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
      temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
      jit_insn_store_relative(function, outAddressValue, offset, temp);
      return temp;
  }
  
! static ILJitValue MarshalReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
      ILExecThread *thread = ILExecThreadCurrent();
--- 1452,1464 ----
  
      }
  
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) return in;
      temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
      jit_insn_store_relative(function, outAddressValue, offset, temp);
      return temp;
  }
  
! static ILJitValue MarshalReturnStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
      ILExecThread *thread = ILExecThreadCurrent();
***************
*** 1189,1194 ****
--- 1470,1478 ----
  
      if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
      {
+ 	    // A returned structure should be a libjit value, so we create one.
+ 	    // Although we could use ILGCAllocAtomic with structSize - it should
+ 	    // work.
  	    structType = jit_type_create_struct(0, 0, 0);
  	    jit_type_set_size_and_alignment(structType, structSize, 0);
  	    newStruct = jit_value_create(function, structType);
***************
*** 1201,1213 ****
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalReturnValue(function, inAddress, type, MARSHAL_ITEM_OF_STRUCTURE, field->offset, outAddress);
  	    }
      }
!     return jit_insn_dup(function, newStruct);
  }
  
! static void MarshalByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
      ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
--- 1485,1498 ----
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalReturnValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE, offset + field->offset, outAddress);
  	    }
      }
!     return newStruct;
  }
  
! #ifdef USE_BYREF_MARSHALING
! static void MarshalByRefValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
      ILJitValue outAddressValue = outAddress;
      ILJitValue temp = jit_value_create(function, _IL_JIT_TYPE_VPTR);
***************
*** 1223,1249 ****
      ILJitValue srcElemAddress;
      ILJitValue newElemAddress;
      ILJitValue counter;
!     ILJitValue arraySize;    
!     ILUInt32 marshalType;
!     char *customName;
!     int customNameLen;
!     char *customCookie;
!     int customCookieLen;
!     ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
!     ILPInvoke *pinv = ILPInvokeFind(method);
!     marshalType = ILPInvokeGetMarshalType(pinv, method, current, &customName, &customNameLen,
! 							&customCookie,	&customCookieLen, type);
! 	
!     if(marshalType == IL_META_MARSHAL_DIRECT && addressKind==MARSHAL_FIRST_LEVEL_VALUE)
!     {
! 	    return;
!     }
      type = ILTypeGetEnumType(type);
- 
      if(!NeedMarshalValue(type)) return;
  
      switch(addressKind)
!     {    
  	    case MARSHAL_FIRST_LEVEL_VALUE:
  	    case MARSHAL_ITEM_OF_STRUCTURE:
  	    case MARSHAL_ITEM_OF_ARRAY:
--- 1508,1519 ----
      ILJitValue srcElemAddress;
      ILJitValue newElemAddress;
      ILJitValue counter;
!     ILJitValue arraySize;
      type = ILTypeGetEnumType(type);
      if(!NeedMarshalValue(type)) return;
  
      switch(addressKind)
!     {
  	    case MARSHAL_FIRST_LEVEL_VALUE:
  	    case MARSHAL_ITEM_OF_STRUCTURE:
  	    case MARSHAL_ITEM_OF_ARRAY:
